---
title: Intl.ListFormat
slug: Web/JavaScript/Reference/Global_Objects/Intl/ListFormat
tags:
  - Class
  - Experimental
  - Internationalization
  - Intl
  - JavaScript
  - ListFormat
---
<div>{{JSRef}}</div>

<p>The <strong><code>Intl.ListFormat</code></strong> object is a constructor for objects that enable language-sensitive list formatting.</p>

<div>{{EmbedInteractiveExample("pages/js/intl-listformat.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{jsxref("Intl/ListFormat/ListFormat", "Intl.ListFormat()")}}</dt>
 <dd>Creates a new <code>ListFormat</code> object.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{jsxref("ListFormat.supportedLocalesOf", "Intl.ListFormat.supportedLocalesOf()")}}</dt>
 <dd>Returns an array containing those of the provided locales that are supported without having to fall back to the runtime's default locale.</dd>
</dl>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt>{{jsxref("ListFormat.prototype.format", "Intl.ListFormat.prototype.format()")}}</dt>
 <dd>Returns a language-specific formatted string representing the elements of the list.</dd>
 <dt>{{jsxref("ListFormat.prototype.formatToParts", "Intl.ListFormat.prototype.formatToParts()")}}</dt>
 <dd>Returns an array of objects representing the different components that can be used to format a list of values in a locale-aware fashion.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_format">Using format</h3>

<p>The following example shows how to create a List formatter using the English language.</p>

<pre class="brush: js notranslate">const list = ['Motorcycle', 'Bus', 'Car'];

 console.log(new Intl.ListFormat('en-GB', { style: 'long', type: 'conjunction' }).format(list));
// &gt; Motorcycle, Bus and Car

 console.log(new Intl.ListFormat('en-GB', { style: 'short', type: 'disjunction' }).format(list));
// &gt; Motorcycle, Bus or Car

 console.log(new Intl.ListFormat('en-GB', { style: 'narrow', type: 'unit' }).format(list));
// &gt; Motorcycle Bus Car
</pre>

<h3 id="Using_formatToParts">Using formatToParts</h3>

<p>The following example shows how to create a List formatter returning formatted parts</p>

<pre class="brush: js notranslate">const list = ['Motorcycle', 'Bus', 'Car'];
console.log(new Intl.ListFormat('en-GB', { style: 'long', type: 'conjunction' }).formatToParts(list));

// [ { "type": "element", "value": "Motorcycle" },
//   { "type": "literal", "value": ", " },
//   { "type": "element", "value": "Bus" },
//   { "type": "literal", "value": ", and " },
//   { "type": "element", "value": "Car" } ];
</pre>

<h2 id="Polyfill">Polyfill</h2>

<p><a href="https://formatjs.io/docs/polyfills/intl-listformat">formatjs Intl.ListFormat polyfill</a></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Intl.ListFormat', '#listformat-objects', 'ListFormat')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Intl.ListFormat")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Intl")}}</li>
</ul>
